from  omniORB import CORBA
import omniORB.interceptors
import omniORB
from poaupdater import uLogging
import os.path
import sys, os

auth_info = None
def add_auth_info(name, ctx):
	if auth_info:
		sid = 0x9c40001
		s = auth_info
		sany = CORBA.Any(CORBA.TypeCode(CORBA.id(s)), s)
		smr = omniORB.cdrMarshal(CORBA.TC_any, sany)
		ctx.append( (sid, smr) )

call_id=0
def add_logging_context(name, ctx):
	global call_id
	sid = 0x9c4000d
	smr = 'uCorba2:%s:%s' % (os.getpid(),call_id)
	ctx.append( (sid, smr) )
	call_id+=1
	uLogging.debug('uCorba2: invoking %s' % name)

omniORB.interceptors.addClientSendRequest(add_auth_info)
omniORB.interceptors.addClientSendRequest(add_logging_context)

class Corba:
	def __init__(self, *tincludes):
		self.orb = omniORB.CORBA.ORB_init(argv = sys.argv +['-ORBverifyObjectExistsAndType', '0'])
		includes = list(tincludes)
		self.includes = includes
		self.includes += [ os.path.join(i,'sdk') for i in includes]
		self.includes += [ os.path.join(i,'sdk/capabilities') for i in includes]
		self.resolver = None
		omniORB.omniidlArguments(['-I'+i for i in self.includes])

	def __importIDL(self, name):
		variants = [name] + [ os.path.join(i,name) for i in self.includes]
		variants += [name+'.idl'] + [ os.path.join(i, name+'.idl') for i in self.includes]
		exists = filter(os.path.exists, variants)
		if not exists:
			raise Exception('%s not found in %s' % (name, self.includes))
		omniORB.importIDL(exists[0])

	def connect(self, host, port = 8354, user='admin', password='1q2w3e'):
		self.__importIDL('PEMNaming')
		import Plesk.Naming
		obj = self.orb.string_to_object('corbaloc:iiop:' + '%s:%d'%(host,port) + '/ObjectResolver')
		self.resolver = obj._narrow(Plesk.Naming.ObjectResolver)

		hub = self.reference('hub', 'Plesk.hub')
		global auth_info
		auth_info = hub.acquire_own_cred(user, password)

	def reference(self, idl, fullName = None, sc_id=0):
		if not self.resolver:
			raise Exception('self.resolver is empty. Please connect first')
		if not fullName:
			fullName = idl
		self.__importIDL(idl)
		moduleName = None
		if '.' in fullName:
			moduleName = '.'.join(fullName.split('.')[0:-1])
		else:
			moduleName = '_GlobalIDL'
		klassName = fullName.replace(moduleName, '').lstrip('.')
		klass = sys.modules[moduleName].__getattribute__(klassName)
		ref = self.resolver.resolve(klass.service_type, sc_id)[0]
		obj = ref._narrow(klass)
		return obj

if __name__ == '__main__':
	capi = Corba('idl', 'platform-idl')
	capi.connect('10.27.75.140')
	dns = capi.reference('DNS_SC.idl', 'Plesk.DNSManagement.sc')
	print dns.listRestrictionRules()
